{$I-}
Program StarFleetI_StarEmu_Initializer;
 Uses Dos,CRT;

Const
          MainMenu : Array[0..2] of String =
                    (' Patch STARFLT.COM; CGA mode to work with VGA cards ',
                     ' StarEMU video refresh rates ',
                     ' Exit back to DOS ');

          NotFound : Array[0..1] of String =
                    ('  STARFLT.COM not found.  ',
                     ' Press Enter to continue. ');

        SENotFound : Array[0..1] of String =
                    ('  STAREMU.COM not found.  ',
                     ' Press Enter to continue. ');

       CannotPatch : Array[0..1] of String =
                    (' Cannot patch STARFLT.COM ',
                     ' Press Enter to continue. ');

    AlreadyPatched : Array[0..1] of String =
                    (' STARFLT.COM is already patched. ',
                     ' Press Enter to continue. ');

      GonnaPatchIt : Array[0..1] of String =
                    (' Patch STARFLT.COM ',
                     ' Do not patch STARFLT.COM. ');

         RatesMenu : Array[0..3] of String =
                    (' Set STAREMU.COM to default 70.0Hz refresh rate ',
                     ' Analyse possible refresh rates ',
                     ' Modify STAREMU.COM''s refresh rate ',
                     ' Back to main menu ');

           Set70Hz : Array[0..1] of String =
                    (' STAREMU.COM refresh rate is now 70.0Hz. ',
                     ' Press Enter to continue. ');


      OriginalData : Array[0..13] of Byte =
                    ($BA,$D4,$03,$BE,$16,$8D,$E8,$26,$FF,$83,$3E,$AF,$8D,$01);

         PatchData : Array[0..13] of Byte =
                    ($B8,$04,$00,$83,$FF,$01,$75,$02,$B0,$05,$CD,$10,$EB,$3C);

var
                 f : File;
             fName : String;
                fB : Array[0..2047] of Byte;

           KeyCode : Integer;
         lSelected : Integer;  { SelectList last chosen }

        H,M,S,S100 : Word;
           ST,ET,T : LongInt;
       FRate,URate : Real;
           EmuRate : Real;
             Rates : Array[0..2] of String;



Function CheckKey:Integer;
 Begin
  If Keypressed then Begin
   KeyCode:=Byte(ReadKey);
   if (KeyCode=0) and (Keypressed) then KeyCode:=-Byte(ReadKey);
   CheckKey:=KeyCode;
  End else Begin
   KeyCode:=0;CheckKey:=0;
  End;
 End;

Procedure DrawScreen;
 Begin
  TextAttr:=$0F;ClrScr;
  GotoXY(18,01);Write('ķ');
  GotoXY(18,02);Write(' InitEMU   v2.50   (C) Jouko Orava,  1996 ');
  GotoXY(18,03);Write('ͼ');
  TextAttr:=$0A;
  GotoXY(07,06);Write('Disclaimer :   The author does not accept any responsibility');
  GotoXY(22,07);Write('for any damage resulting from the use or misuse');
  GotoXY(22,08);Write('of these programs. In other words, you use these');
  GotoXY(22,09);Write('programs (InitEmu and StarEmu) at your own risk.');
  GotoXY(14,30);Write('Select option using cursor keys and Enter to accept.');
  GotoXY(23,37);Write('e-mail: JOOrava@Rock.Helsinki.FI');
  GotoXY(19,39);Write('Snail-mail: Jouko Orava');
  GotoXY(31,40);Write('Hakaniemenranta 30 B 66');
  GotoXY(31,41);Write('FIN-00530 Helsinki');
  GotoXY(31,42);Write('Finland');
  gotoXY(1,38);TextAttr:=$00;Write(' ');GotoXY(1,38);
 End;

Function SelectList(MaxIndex,Default:Integer;s:Array of String):Integer;
var Index:Integer;
 Begin
  DrawScreen;
  for Index:=0 to MaxIndex do Begin
   if Index=Default then TextAttr:=$4F else TextAttr:=$0E;
   GotoXY((80-byte(s[Index][0])) div 2,15+Index*2);
   Write(s[Index]);
  End;
  Index:=Default;CheckKey;GotoXY(1,38);
  While (KeyCode<>13) do if KeyCode<>0 then Begin
   TextAttr:=$0E;
   GotoXY((80-byte(s[Index][0])) div 2,15+Index*2);Write(s[Index]);
   if (KeyCode=-72) and (Index>0) then dec(Index);
   if (KeyCode=-80) and (Index<MaxIndex) then inc(Index);
   TextAttr:=$4F;GotoXY((80-byte(s[Index][0])) div 2,15+Index*2);
   Write(s[Index]);GotoXY(1,38);
  CheckKey;End else CheckKey;
  SelectList:=Index+1;lSelected:=Index+1;
 End;

Function memcmp(MaxIndex:Word;a,b:array of byte):integer;
 var Index:Word;
 Begin
  Index:=0;while(Index<=MaxIndex) and (a[Index]=b[Index]) do inc(Index);
  if (Index>MaxIndex) then memcmp:=0
    else if (a[Index]<b[Index]) then memcmp:=1
    else if (a[Index]>b[Index]) then memcmp:=-1
    else memcmp:=0;
 End;

Procedure TryPatching;
 Begin
  DrawScreen;TextAttr:=$0F;
  Assign(f,'STARFLT.COM');reset(f,1);
  if IOResult=0 then Begin
     Seek(f,$00008CCC);Blockread(f,fB,14);
     Seek(f,$00008CCC);delay(1000);
     if memcmp(13,fB,OriginalData)=0 then Begin { Patching possible }
       if SelectList(1,0,GonnaPatchIt)=1 then BlockWrite(f,PatchData,14);
       lSelected:=1;
      End else if memcmp(13,fB,PatchData)=0 then Begin { Already patched }
       lSelected:=SelectList(1,0,AlreadyPatched);
       lSelected:=1;
      End else Begin { Patching not possible }
       lSelected:=SelectList(1,0,CannotPatch);
       lSelected:=1;
      End;
     Close(f);
   End else Begin
    lSelected:=SelectList(1,0,NotFound);
    lSelected:=1;
   End;
 End;

Procedure ToSpecial;
 Assembler;
  Asm
    mov  ax,00083h    ;{ Mode Set }
    int 010h
    mov  ax,01003h    ;{ Blinking off, safest way (Other: 3C0/10 = 20h }
    xor  bx,bx
    int 010h
    mov  ax,01000h
    mov  bx,00013h    ;{ Horizontal Panning to zero (Other: 3C0/13 = 00h }
    int 010h

    mov  dx,003C2h
    mov  al,00063h    ;{ Clock (25MHz) & 400 scan lines }
    out  dx,al

    mov  dx,003C4h
    mov  ax,00101h    ;{ Character width }
    out  dx,ax
    mov  ax,00503h    ;{ Character Bank (both) bank 1 == 16k }
    out  dx,ax

    mov  dx,003D4h
    mov  ax,0C009h    ;{ Double scans + 1-pix tall characters }
    out  dx,ax

    mov  dx,003C4h
    mov  ax,00C02h    ;{ Write Plane Mask }
    out  dx,ax
    mov  dx,003CEh
    mov  ax,00004h    ;{ Read Plane Number }
    out  dx,ax

    mov  ax,0B800h
    mov  es,ax
    xor  si,si
@Loop:
    mov  ax,es:[si]
    mov  es:[si],ax
    add  si,02h
    cmp  si,04000h
    jb  @Loop

    mov  dx,003C4h
    mov  ax,00C02h
    out  dx,ax

    mov  ax,00F0Fh    ;{ Right Pixel in Low Nibble }
@Loop2:
    mov  es:[si],ax
    add  si,02h
    jns @Loop2

    mov  dx,003CEh
    mov  ax,00204h    ;{ Read Plane Number }
    out  dx,ax

 End;

Procedure ToNormal;
 Assembler;
 Asm
   mov  ax,0B800h
   mov  es,ax
   mov  dx,003C4h
   mov  ax,00F02h
   out  dx,ax
   xor  si,si
@L:
   mov  ax,es:[si]
   mov  es:[si],ax
   add  si,2
   cmp  si,04000h
   jb  @L
   mov  ax,00085h
   int 010h
 End;

Procedure Update;
 Assembler;
  Asm
   push ds
   push bp
   mov  ax,0B800h
   mov  ds,ax
   mov  dx,003C4h
   mov  ax,00302h
   out  dx,ax
   xor  si,si
   xor  di,di
   mov  al,014h
   mov  cl,al
   mov  bp,02000h
@Loop1:
   mov  bx,[si+000h]        ;
   mov  ah,bl               ;
   mov  dx,[si+002h]        ;
   mov  ch,dl               ;
   mov [di+000h],ax         ;
   mov [di+002h],bx         ;
   mov [di+004h],cx         ;
   mov [di+006h],dx        ;
   add  si,bp
   add  di,0A0h
   mov  bx,[si+000h]
   mov  ah,bl
   mov  dx,[si+002h]
   mov  ch,dl
   mov [di+000h],ax
   mov [di+002h],bx
   mov [di+004h],cx
   mov [di+006h],dx
   sub  si,01FFCh
   sub  di,098h
   dec  cl
   jnz @Loop1
   add  di,0A0h
   mov  cl,al
   cmp  si,bp
   jb  @Loop1

   mov  dx,003C4h
   mov  ax,00C02h
   out  dx,ax

   pop  bp
   pop  ds
 End;

Procedure SetMode(n:Word);
 Assembler;
 Asm
  mov  ax,n
  int 010h
 End;

Function Real2Str(R:Real;Numbers,Decimals:integer):String;
 var s:String;
 Begin
  Str(R:Numbers:Decimals,S);
  Real2Str:=S;
 End;

Procedure Analyse(ToWait:Boolean);
var I:Word;
 Begin
  SetMode(5);
  for I:=0 to 7999 do mem[$b800:i]:=random(255);
  for I:=0 to 7999 do mem[$b800:8192+i]:=random(255);
  ToSpecial;

  { Find out update rate }
  GetTime(H,M,S,S100);ST:=S100+S*100+M*6000+H*360000;T:=0;ET:=ST+1;
  While (ET-ST<500) do Begin
   Update;
   GetTime(H,M,S,S100);ET:=S100+S*100+M*6000+H*360000;inc(T);
   if ET<ST then begin;ET:=ST;T:=0;End;
  End;
  URate:=(100.0*T)/(ET-ST);

  { Find out video refresh rate }
  GetTime(H,M,S,S100);ST:=S100+S*100+M*6000+H*360000;T:=0;ET:=ST+1;
  While (ET-ST<500) do Begin
   Asm
    mov  dx,003DAh
  @TZ:
    in   al,dx
    test al,08h
    jnz @TZ
  @TNZ:
    in   al,dx
    test al,08h
    jz  @TNZ
   End;
   GetTime(H,M,S,S100);ET:=S100+S*100+M*6000+H*360000;inc(T);
   if ET<ST then begin;ET:=ST;T:=0;End;
  End;
  FRate:=(100.0*T)/(ET-ST);

  ToNormal;TextMode(CO80+Font8x8);

  if towait then Begin

    Rates[0]:=' Video refresh rate is '+Real2Str(FRate,7,2)+'Hz ';
    Rates[1]:=' StarEMU max refresh rate is '+Real2Str(URate,7,2)+'Hz ';
    Rates[2]:=' Press Enter to continue ';

    lSelected:=SelectList(2,0,Rates);
  End;
 End;

Procedure Modify;
var rMul,rDiv:Word;
 Begin
  if (FRate=0) or (URate=0) then Analyse(False);
  assign(f,'STAREMU.COM');reset(f,1);
  if IOResult=0 then Begin
    Seek(f,$00000000);BlockRead(f,fB,16);
    rMul:=fB[6]+256*fB[7];rDiv:=fB[8]+256*fB[9];
    EmuRate:=round(10240.0*rMul/rDiv)/10;
    DrawScreen;
    TextAttr:=$0E;
    GotoXY(23,15);Write('Change the rate with cursor keys,');
    GotoXY(23,16);Write('Enter accepts and ESC backs out.');
    TextAttr:=$0F;
    GotoXY(24,20);Write('Video refresh rate is ',FRate:7:2,' Hz ');
    GotoXY(22,21);Write('Maximum StarEMU rate is ',URate:7:2,' Hz ');
    TextAttr:=$4F;GotoXY(34,24);Write(' ',EmuRate:7:2,' Hz ');
    TextAttr:=$0F;GotoXY(25,25);Write(' (Uses ',100.0*EmuRate/URate:7:2,'% of CPU power) ');
    CheckKey;While (KeyCode<>13) and (Keycode<>27) do if KeyCode<>0 then Begin
     if EmuRate<1.0 then EmuRate:=1.0;
     if KeyCode=-72 then EmuRate:=EmuRate+0.1;
     if KeyCode=-80 then EmuRate:=EmuRate-0.1;
     if KeyCode=-75 then EmuRate:=EmuRate-0.5;
     if KeyCode=-77 then EmuRate:=EmuRate+0.5;
     TextAttr:=$4F;GotoXY(34,24);Write(' ',EmuRate:7:2,' Hz ');
     TextAttr:=$0F;GotoXY(25,25);Write(' (Uses ',100.0*EmuRate/URate:7:2,'% of CPU power) ');
     CheckKey;
    End else CheckKey;
    if KeyCode=13 then Begin
     rDiv:=8192;rMul:=Round(EMURate*rDiv/1024.0);
     Seek(f,$00000000);
     fB[6]:=rMul and 255;fB[7]:=rMul div 256;
     fB[8]:=rDiv and 255;fB[9]:=rDiv div 256;
     BlockWrite(f,fB,16);
    End;
    Close(F);
   End else Begin
    lSelected:=SelectList(1,0,SENotFound);
  End;
 End;

Procedure RMenu;
 Begin
  lSelected:=0;
  While lSelected<>-1 do case Selectlist(3,lSelected,RatesMenu) of
    1:Begin { to default }
       Assign(f,'STAREMU.COM');reset(f,1);
       if IOResult=0 then Begin
         Seek(f,$00000000);blockread(f,fB,16);
         fB[6]:=$08;fB[7]:=$00;fB[8]:=$75;fB[9]:=$00;
         Seek(f,$00000000);BlockWrite(f,fB,16);
         Close(F);
         lSelected:=SelectList(1,0,Set70Hz);
        End else Begin
         lSelected:=SelectList(1,0,SENotFound);
        End;
       lSelected:=3;
      End;
    2:Begin
       Analyse(True);
       lSelected:=2;
      End;
    3:Begin
       Modify;
       lSelected:=3;
      End;
    4:lSelected:=-1;
  End;
  lSelected:=2;
 End;

Begin
 TextMode(CO80+Font8x8);lSelected:=1;FRate:=0;URate:=0;

 while SelectList(2,lSelected-1,MainMenu) <>3 do case lSelected of
   1 : TryPatching;
   2 : RMenu;
  End;

 TextMode(LastMode);
End.

